// Decodierung vom GGA-Daten. 
// NO GPS-FIX: Validity, Status, Satelliten
//    GPS-FIX: #A0="HIGH": Lat, Lon, Locator (#A1="HIGH") or Hoehe (#A1="LOW"), GMT
//             #A0="LOW": Validity, Status, Satelliten

 #include <string.h>
 #include <ctype.h>
 #include "U8glib.h"

 U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);

float latitude;
float longitude;
float hoehe;
float value_read;
float volts;
String GPSStringbuf = "";
String grad = "";
String zeit = "";
String zeit_neu = "";
String GPSString = "";
String ns, ew;
int status,mrk;
int satelliten;
int ledPin = 13;                  // LED test pin
boolean stringComplete = false;
char floatbuf[32];
char gradbuf[4];
long upc = 1; 
int addr = 0;

char* LetStr[]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X"};
char* NumStr[]={"0","1","2","3","4","5","6","7","8","9"};
String Loc;

float scrap;  // variable for calculations
float loclat;  // variable for LOC calculations
float loclong;  // variable for LOC calculations

///////////////////////////////////////////////////////// 
void setup()
{
  Serial.begin(9600); 
  Serial.println("WAIT!");
    delay(100);
  pinMode(ledPin, OUTPUT);       // Initialize LED pin
  GPSString.reserve(100);        // reserviert 100 Zeichen

  pinMode(14, INPUT_PULLUP); // A0 as input ( "H"= Pos ; "L"= Status )  
  pinMode(15, INPUT_PULLUP); // A1 as input ( "H"= Loc ; "L"= Alti )
  pinMode(16, INPUT_PULLUP); // A2 as input ( "L"= hour+1 )
  pinMode(17, INPUT_PULLUP); // A3 as input ( "L"= hour+2 ) 
 
 // ------------------ Display Startscreen ----------------------- 
  u8g.firstPage();  
  do {
  u8g.setColorIndex(1);
  u8g.drawLine(1,1,127,1);
  u8g.drawFrame(1,18,127,45);
  u8g.setFont(u8g_font_ncenB10);
  u8g.setPrintPos(8,16);
  u8g.print("GPS-DECODER"); 
  u8g.setPrintPos(7,43);
  u8g.print("(C) DJ7OO 2015"); 
  } 
  while ( u8g.nextPage() );
  delay(3000);
}
 
/////////////////////////////////////////////////////////// 
void loop()
{
  while (Serial.available()) 
  //Solange Daten verfügbar sind in whileschleife bleiben...
  {
    char inChar = (char)Serial.read(); 
    //und alle Daten  einlesen
    GPSString += inChar;
    if (inChar == '\n') {
    stringComplete = true;
    }
  }
  if (stringComplete) 
  {    
    if(GPSString.indexOf("$GPGGA") != -1) 
    //...überprüfen den richtigen Datensatz...
    {
      GPSString.replace("$GPGGA,", ""); 
      //...und entferne den Anfang.

   int sensorVal1 = digitalRead(14);  
   int sensorVal2 = digitalRead(15);  
   int sensorVal3 = digitalRead(16);  
   int sensorVal4 = digitalRead(17);  

//----------------time----------------------------------------------
      zeit = GPSString.substring(0, 2); //Zerlegt den Hauptstring in Stunde, Minute und Sekunde

  if (sensorVal3 == LOW) 
    { add_1_hour(); 
      zeit = zeit_neu; }
      else
  if (sensorVal4 == LOW) 
    { add_2_hour(); 
      zeit = zeit_neu; }

      zeit += ":";
      zeit += GPSString.substring(2, 4);
      zeit += ":";
      zeit += GPSString.substring(4, 6);
 
//----------------latitude ------------------------------------------      
      GPSStringbuf = GPSString.substring(position(1), position(2) - 1); 
      //Zerlegt an Kommas, schneidet Breitengrad heraus
      grad = GPSStringbuf.substring(0, 2); 
      //trennt die ganzen Grad ab
      GPSStringbuf = GPSStringbuf.substring(2, 10); 
      //erzeugt substring aus dem Rest
      grad.toCharArray(gradbuf, sizeof(gradbuf)); 
      //String ⇒ CharArray
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      //String ⇒ CharArray
      latitude = atof(gradbuf) + (atof(floatbuf) / 60.00); 
      //Umwandlung von CharArray zu float, umrechnung in Gradmaß gemäß XXYY.ZZZZ ⇒ XX° + (YY.ZZZZ / 60)°.

//----------------ns ---------------------------------------------------------------------
      GPSStringbuf = GPSString.substring(position(2), position(3) - 1);      
      ns = GPSStringbuf.substring(0, 1);           

//----------------longitude -----------------------------------------                  
      GPSStringbuf = GPSString.substring(position(3), position(4) - 1); //siehe Breitengrad
      grad = GPSStringbuf.substring(0, 3);
      GPSStringbuf = GPSStringbuf.substring(3, 11);
      grad.toCharArray(gradbuf, sizeof(gradbuf));
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf));
      longitude = atof(gradbuf) + (atof(floatbuf) / 60.00);

//----------------ew---------------------------------------------------------------------
      GPSStringbuf = GPSString.substring(position(4), position(5) - 1); 
      ew = GPSStringbuf.substring(0, 1 );       
  
//----------------status---------------------------------------------
      GPSStringbuf = GPSString.substring(position(5), position(6) - 1); //zerlegen zwischen 5. und 6. Komma
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf));  //String ⇒ CharArray
      status = atoi(floatbuf); //CharArray ⇒ Integer    
 
//----------------satelites-----------------------------------------  
      GPSStringbuf = GPSString.substring(position(6), position(7) - 1);  //zerlegen zwischen 6. und 7. Komma
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf));  //String ⇒ CharArray
      satelliten = atoi(floatbuf); //CharArray ⇒ Float  
 
//----------------altitude ----------------------------------------  
      GPSStringbuf = GPSString.substring(position(8), position(9) - 1);  //zerlegen zwischen 7. und 8. Komma        
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf));  //String ⇒ CharArray
      hoehe = atof(floatbuf); //CharArray ⇒ Float

//---------------------- calculate Maidenhead Locator -------------
     loclat = latitude   * 1000000;
     loclong = longitude * 1000000;
 
     if (ew == "E") loclong = (loclong) + 180000000;
     if (ew == "W") loclong = 180000000 - (loclong);
 
     if (ns == "N")  loclat = loclat + 90000000;
     if (ns == "S")  loclat = 90000000 - loclat;   

     Loc = (LetStr[int(loclong/20000000)]);      
     Loc = Loc + (LetStr[int(loclat/10000000)]);         
     scrap = loclong  -   (20000000 * int (loclong/20000000));    
     Loc = Loc + (NumStr[int(scrap*10/20/1000000)]);     
     scrap = loclat  -  (10000000 * int (loclat/10000000));   
     Loc = Loc + (NumStr[int(scrap/1000000)]);    
     scrap = (loclong / 2000000)  -   (int (loclong/2000000));       
     Loc = Loc + (LetStr[int(scrap * 24)]);  
     scrap = (loclat / 1000000)  -   (int (loclat/1000000));
     Loc = Loc + (LetStr[int(scrap * 24)]);   

//-------------- Show while waiting for GPS-FIX -----------------
  if(status==0)
      {
      Serial.println(" ");
      Serial.print(F("Time:        "));
      Serial.println(zeit);
      Serial.print(F("Status:      "));
      Serial.println(status);
      Serial.print(F("Satelliten:  "));
      Serial.println(satelliten);
      
  u8g.firstPage();  
  do {
  u8g.setColorIndex(1);
  u8g.drawLine(1,1,127,1);
  u8g.drawFrame(1,18,127,45);

  u8g.setFont(u8g_font_ncenB10);
if (sensorVal1 == LOW) 
  {
  value_read = analogRead(21);      // read analog value from #A7  
  volts = (value_read/157);
  u8g.setPrintPos(30,16);
  u8g.print(volts);  
  u8g.print(" Volts");
  }
  else
  {  
  u8g.setPrintPos(35,16);
  u8g.print(zeit);
  }
  
  u8g.setPrintPos(7,32);
  u8g.print("WAIT FOR GPS"); 
  
  u8g.setPrintPos(7,46);
  u8g.print("Status:");
  u8g.setPrintPos(110,46);
  u8g.print(status);      

  u8g.setPrintPos(7,60);
  u8g.print("Satellites:");
  u8g.setPrintPos(110,60);
  u8g.print(satelliten);
  } 
  while ( u8g.nextPage() );
    }
    else 
    {

//-------------------- Show after GPS-FIX ---------------------    
      Serial.println(" ");
      Serial.print(F("Time:        "));
      Serial.println(zeit);
      Serial.print(F("Sats:        "));
      Serial.println(satelliten);
      Serial.print(F("Status:      "));
      Serial.println(status);
      Serial.print(F("Breitengrad: "));
      Serial.println(latitude, 5);
      Serial.print(F("Laengengrad: "));
      Serial.println(longitude, 5);    
      Serial.print(F("Hoehe:       "));
      Serial.print(hoehe,0);
      Serial.println(F("m"));
      Serial.print(F("Locator:     "));
      Serial.println(Loc); 

// ----------------- show status if #A0 = "LOW" -----------------
  if (sensorVal1 == LOW) 
  { 
  u8g.firstPage();  
  do {
  u8g.setColorIndex(1);
  u8g.drawLine(1,1,127,1);
  u8g.drawFrame(1,18,127,45);

  u8g.setFont(u8g_font_ncenB10);
  if (sensorVal1 == LOW) 
  {
  value_read = analogRead(21);      // read analog value from #A7  
  volts = (value_read/157);
  u8g.setPrintPos(30,16);
  u8g.print(volts);  
  u8g.print(" Volts");
  }
  else
  {
  u8g.setPrintPos(35,16);
  u8g.print(zeit);
  } 
   
  u8g.setPrintPos(7,32);
  u8g.print("   GPS VALID "); 
    
  u8g.setPrintPos(7,46);
  u8g.print("Status:");
  u8g.setPrintPos(110,46);
  u8g.print(status);      

  u8g.setPrintPos(7,60);
  u8g.print("Satellites:");
  u8g.setPrintPos(110,60);
  u8g.print(satelliten);
  } 
  while ( u8g.nextPage() );
  }
  else 
  {
// ----------------- show status if #A0 = "HIGH" -----------------
  u8g.firstPage();  
  do {
  u8g.setColorIndex(1);
  u8g.drawLine(1,1,127,1);
  u8g.drawFrame(1,18,127,45);

  u8g.setFont(u8g_font_ncenB10);
  u8g.setPrintPos(35,16);
  u8g.print(zeit);

  u8g.setPrintPos(7,32);
  u8g.print("LAT: ");
  u8g.print(latitude,5);      
  u8g.setPrintPos(110,32);
  u8g.print(ns);      

  u8g.setPrintPos(7,46);
  u8g.print("LON: ");
  u8g.print(longitude,5);
  u8g.setPrintPos(110,46);
  u8g.print(ew);      

// ------------ show altitudes if #A1 = "LOW" --------------------
  if (sensorVal2 == LOW) 
{ u8g.setPrintPos(7,60);
  u8g.print("ALT: "); 
  u8g.print(hoehe,0); 
  u8g.print("m"); }
  else
// ------------ show upcounter if #A1 = "HIGH" --------------------
{ u8g.setPrintPos(35,60);
  u8g.print(Loc); }
  } 
  while ( u8g.nextPage() );
  }
 }
} 
    status = 0;
    satelliten = 0;
    latitude = 0;
    longitude = 0;
    hoehe = 0;
    GPSString = "";
    GPSStringbuf = "";
    stringComplete = false;
//  delay(5000);
  }
}

// subroutine: deliveres position of n komma in NMEA datastring 
// ---------------------------------------------------------------
int position(int number) 
{
  int i = 0;
  int position = 0;
  while(i < number)
  {
    position = GPSString.indexOf(",", position) + 1; //Beschafft die Position des ersten Kommas, wird ein weiteres Komma gesucht wird an der Position des letzen + 1 gestartet.
    i++;
  }
  return position;
}

/////////////////////////////////////////////////////////////////////
void add_1_hour()
{
if(zeit=="00") { zeit_neu="01"; } else
if(zeit=="01") { zeit_neu="02"; } else
if(zeit=="02") { zeit_neu="03"; } else
if(zeit=="03") { zeit_neu="04"; } else
if(zeit=="04") { zeit_neu="05"; } else
if(zeit=="05") { zeit_neu="06"; } else
if(zeit=="06") { zeit_neu="07"; } else
if(zeit=="07") { zeit_neu="08"; } else
if(zeit=="08") { zeit_neu="09"; } else
if(zeit=="09") { zeit_neu="10"; } else
if(zeit=="10") { zeit_neu="11"; } else
if(zeit=="11") { zeit_neu="12"; } else
if(zeit=="12") { zeit_neu="13"; } else
if(zeit=="13") { zeit_neu="14"; } else
if(zeit=="14") { zeit_neu="15"; } else
if(zeit=="15") { zeit_neu="16"; } else
if(zeit=="16") { zeit_neu="17"; } else
if(zeit=="17") { zeit_neu="18"; } else
if(zeit=="18") { zeit_neu="19"; } else
if(zeit=="19") { zeit_neu="20"; } else
if(zeit=="20") { zeit_neu="21"; } else
if(zeit=="21") { zeit_neu="22"; } else
if(zeit=="22") { zeit_neu="23"; } else
if(zeit=="23") { zeit_neu="00"; } 
}

/////////////////////////////////////////////////////////////////////
void add_2_hour()
{
if(zeit=="00") { zeit_neu="02"; } else
if(zeit=="01") { zeit_neu="03"; } else
if(zeit=="02") { zeit_neu="04"; } else
if(zeit=="03") { zeit_neu="05"; } else
if(zeit=="04") { zeit_neu="06"; } else
if(zeit=="05") { zeit_neu="07"; } else
if(zeit=="06") { zeit_neu="08"; } else
if(zeit=="07") { zeit_neu="09"; } else
if(zeit=="08") { zeit_neu="10"; } else
if(zeit=="09") { zeit_neu="11"; } else
if(zeit=="10") { zeit_neu="12"; } else
if(zeit=="11") { zeit_neu="13"; } else
if(zeit=="12") { zeit_neu="14"; } else
if(zeit=="13") { zeit_neu="15"; } else
if(zeit=="14") { zeit_neu="16"; } else
if(zeit=="15") { zeit_neu="17"; } else
if(zeit=="16") { zeit_neu="18"; } else
if(zeit=="17") { zeit_neu="19"; } else
if(zeit=="18") { zeit_neu="20"; } else
if(zeit=="19") { zeit_neu="21"; } else
if(zeit=="20") { zeit_neu="22"; } else
if(zeit=="21") { zeit_neu="23"; } else
if(zeit=="22") { zeit_neu="00"; } else
if(zeit=="23") { zeit_neu="01"; } 
}


